--[[ Challenges / Tutorials

TODO CONSTANTLY: refine and consolidate language
TODO: Change recharge time II to be deal x damage over 10 seconds

show held wand stands on screen during challenges
spell wrap still needs expansion

friendly fire spells
precendence of pattern spells


wand refresh DOES NOT CALL move hand to discarded, so talk about what that means

velocity damage
    include the new accelerative homing spell

add a set of homing challenges? maybe

there are like 4 bugs with the fricken spell bar
    having inventory open breaks stuff
    properly clear out spells make sure there is no leftover weirdness
    
Extra Modifiers system (and how it stacks with each projectile spell)

materials / trick blood money

Multicast Set
    Spread Reduction (Arrows)

Peculiarities
    Healing Bolt Usage (show them that the bullshit description is a lie)
    Spells to Power
    Explosion Caching

Piercing Shot
    show how powerful (and dangerous) it can be
    show how to make it useful without being dangerous
    show how it can break the game with infinite triggers

Always Cast Multicast and Spells Per Cast

Making Limited Spells Unlimited

Showcase the difference between Sparkbolt Trigger and Trigger -> Sparkbolt

Infinite Lifetime (magic number)

]]

dofile_once( "mods/spell_lab/files/lib/helper.lua" );
dofile_once( "mods/spell_lab/files/scripts/loadout_helper.lua" );


--[[ This section is for avoiding the pixel scene cache limitation ]]
    function spiral(n)
        local r = math.floor( ( math.sqrt( n + 1 ) - 1 ) / 2 ) + 1;
        local p = (8 * r * (r - 1)) / 2;
        local en = r * 2;
        local a = (1 + n - p) % (r * 8);
        local x = 0;
        local y = 0;
        local s = math.floor(a / (r * 2));
        if s == 0 then
            x = a - r;
            y = -r;
        elseif s == 1 then
            x = r;
            y = (a % en) - r;
        elseif s == 2 then
            x = r - (a % en);
            y = r;
        elseif s == 3 then
            x = -r;
            y = r - (a % en);
        end
        return x, y;
    end

    local pixel_scenes_loaded = tonumber( GlobalsGetValue( "spell_lab_pixel_scenes_loaded","0" ) );
    local last_pixel_scene = "";
    function load_pixel_scene( filepath, x, y )
        if last_pixel_scene ~= filepath then
            local step = 1;
            local px, py = spiral( pixel_scenes_loaded );
            px = px * step + x;
            py = py * step + y;
            --print( "Loading pixel scene "..filepath.." at "..px..","..py );
            EntityLoad( filepath, px, py );
            pixel_scenes_loaded = pixel_scenes_loaded + 1;
            GlobalsSetValue( "spell_lab_pixel_scenes_loaded", tostring( pixel_scenes_loaded ) );
        end
    end
--

local ROOMS = {
    Small = {
        filepath = 'mods/spell_lab/files/biome_impl/challenge_small/init.xml',
        dummy_offset = { x = 0, y = 0 },
        light_offset = { x = 0, y = 0 },
    }, 
    Wide = {
        filepath = 'mods/spell_lab/files/biome_impl/challenge_wide/init.xml',
        dummy_offset = { x = 160, y = 10 },
        light_offset = { x = 90, y = 0 },
    },
    Prison = {
        filepath = 'mods/spell_lab/files/biome_impl/challenge_prison/init.xml',
        dummy_offset = { x = 160, y = 10 },
        light_offset = { x = 90, y = 0 },
    },
    Split = {
        filepath = 'mods/spell_lab/files/biome_impl/challenge_split/init.xml',
        dummy_offset = { x = 160, y = 10 },
        light_offset = { x = 90, y = 0 },
    },
}

local function load_room( room, x, y )
    load_pixel_scene( room.filepath, x, y );
    local dummy = nil;
    if room.dummy_offset ~= nil then
        dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x + room.dummy_offset.x, y + room.dummy_offset.y );
        EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
    end

    local light = nil;
    if room.light_offset ~= nil then
        light = EntityLoad( "mods/spell_lab/files/entities/area_light.xml", x + room.light_offset.x , y + room.light_offset.y );
        EntityAddTag( light, "spell_lab_challenge_cleanup" );
    end
    return dummy, light;
end

local function total_damage_challenge( total_damage, room, challenge )
    challenge.description = string.format( "Deal %s or more total damage to the target dummy", decimal_format( total_damage ) );
    challenge.initialization_callback = function( challenge, player_entity )
        EntityApplyTransform( player_entity, 14600, -7000 );
        local x, y = EntityGetTransform( player_entity );
        GameSetCameraPos( x, y );

        local dummy, light = load_room( room, x, y );

        handle_loadout( player_entity, challenge.loadout );

        challenge.data = challenge.data or {};
        challenge.data.dummy = dummy;
        challenge.validation_callback = function( challenge, player_entity )
            local tracked_damage = EntityGetVariableNumber( challenge.data.dummy, "spell_lab_tracked_damage", 0 );
            return tracked_damage >= total_damage;
        end
        challenge.progress_callback = function( challenge, player_entity )
            local damage = ( math.floor( EntityGetVariableNumber( challenge.data.dummy, "spell_lab_tracked_damage", 0 ) * 100 ) / 100 );
            return {
                "Total Damage Dealt - "..decimal_format( damage, 2 ).."/"..decimal_format( total_damage, 2 )
            };
        end
    end
end

local function damage_per_frames_challenge( dps, frames, room, challenge, player_entity )
    if frames == 60 then
        challenge.description = string.format( "Deal %s or more damage per second to the target dummy", decimal_format( dps ) );
    else
        challenge.description = string.format( "Deal %s or more damage to the target dummy in %s seconds or less", decimal_format( dps ), math.floor( frames / 60 * 10 ) / 10 );
    end
    challenge.initialization_callback = function( challenge, player_entity )
        GlobalsSetValue("spell_lab_highest_dps","0");

        EntityApplyTransform( player_entity, 14600, -7000 );
        local x, y = EntityGetTransform( player_entity );
        GameSetCameraPos( x, y );

        local dummy, light = load_room( room, x, y );
        EntitySetVariableNumber( dummy, "damage_per_frames", frames );

        handle_loadout( player_entity, challenge.loadout );
        challenge.data = challenge.data or {}
        challenge.data.dummy = dummy;
        challenge.data.highest_dps = 0;
        challenge.validation_callback = function( challenge, player_entity )
            local highest_dps = tonumber( GlobalsGetValue("spell_lab_highest_dps","0") );
            if highest_dps > challenge.data.highest_dps then
                challenge.data.highest_dps = highest_dps;
            end
            return challenge.data.highest_dps >= dps;
        end
        challenge.progress_callback = function( challenge, player_entity )
            local current_dps = ( math.floor( challenge.data.highest_dps * 100 ) / 100 );
            local now = GameGetFrameNum();
            local first_hit_frame = EntityGetVariableNumber( challenge.data.dummy, "first_hit_frame", now );
            local time_in_seconds = ( now - first_hit_frame ) / 60;
            local time = ( math.min( frames / 60, math.floor( time_in_seconds * 100 ) / 100 ) );
            return {
                "Time - "..decimal_format( time, 2 ).."/"..decimal_format( math.floor( frames / 60 * 100 ) / 100, 2 ),
                "Highest DPS - "..decimal_format( current_dps, 2 ).."/"..decimal_format( dps, 2 );
            };
        end
    end
end

local function single_hit_damage_challenge( damage, room, challenge, player_entity )
    challenge.description = string.format( "Deal %s or more damage to the target dummy in a single hit", decimal_format( damage ) );

    challenge.initialization_callback = function( challenge, player_entity )
        GlobalsSetValue("spell_lab_highest_damage_dealt","0")
        EntityApplyTransform( player_entity, 14600, -7000 );
        local x, y = EntityGetTransform( player_entity );
        GameSetCameraPos( x, y );

        local dummy, light = load_room( room, x, y );

        handle_loadout( player_entity, challenge.loadout );

        challenge.data = challenge.data or {};
        challenge.data.dummy = dummy;
        challenge.data.highest_damage_dealt = 0;
        challenge.validation_callback = function( challenge, player_entity )
            local highest_damage = tonumber( GlobalsGetValue("spell_lab_highest_damage_dealt","0") );
            if highest_damage > challenge.data.highest_damage_dealt then
                challenge.data.highest_damage_dealt = highest_damage;
            end
            return challenge.data.highest_damage_dealt >= damage;
        end
        challenge.progress_callback = function( challenge, player_entity )
            local current_highest_damage = math.floor( challenge.data.highest_damage_dealt * 100 ) / 100;
            return {
                "Highest Damage Dealt - "..decimal_format( current_highest_damage, 2 ).."/"..decimal_format( damage, 2 )
            };
        end
    end
end

challenges =
{
    { name = "Wand Building Basics - Introduction",
        flag = "challenge_basics",
        preprocessor_callback = function( challenge ) total_damage_challenge( 50, ROOMS.Wide, challenge ); end,
        hints = {
            "Put a projectile spell on your wand and shoot the target dummy",
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 30, -- mana charge speed
                        mana_max = 100, -- mana max
                    }
                },
            },
        }
    },
    { name = "Wand Building Basics - Cast Delay",
        flag = "challenge_basics_cast_delay",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 75, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Cast Delay is the time between individual spell casts",
            "Wands have a natural Cast Delay which is applied to every cast",
            "Projectiles have their own Cast Delay modifier which may be positive (slower) or negative (faster)",
            "Casting a Sparkbolt (+0.05s) on a Wand with 0.15s Cast Delay results in about 5 shots every second (0.20s)",
        },
        examples = {
            {"BUBBLESHOT"},
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 0, -- recharge time in frames
                        fire_rate_wait = 9, -- cast delay in frames
                        spread_degrees = -2, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
            }
        },
    },
    { name = "Wand Building Basics - Recharge Time I",
        flag = "challenge_basics_recharge_time_1",
        preprocessor_callback = function( challenge ) total_damage_challenge( 200, ROOMS.Wide, challenge ); end,
        hints = {
            "Unlike Cast Delay, Recharge Time is applied when your wand has no spells left to cast",
            "Wands with high Recharge Time are generally not very useful, though there are ways to mitigate it",
            "Putting a lot of separate casts on a wand with high Recharge Time can mitigate the effect",
        },
        examples = {
            {"BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT","BUBBLESHOT"},
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 10, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 7, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                }
            }
        },
    },
    { name = "Wand Building Basics - Recharge Time II",
        flag = "challenge_basics_recharge_time_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 150, 600, ROOMS.Wide, challenge ); end,
        hints = {
            "Switching wands or opening your inventory will reset the casts on your wands",
            "This trick can be used to completely negate high recharge times as long as you have more than 1 cast on your wand",
            "Set up two wands and switch between the wands before casting all of the spells",
        },
        examples = {
            {"SPITTER","SPITTER","SPITTER","SPITTER","SPITTER"},
        },
        available_actions = {
            "SPITTER"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 240, -- recharge time in frames
                        fire_rate_wait = 12, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 240, -- recharge time in frames
                        fire_rate_wait = 12, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
            }
        },
    },
    { name = "Wand Building Basics - Spells Per Cast",
        flag = "challenge_basics_spells_per_cast",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 60, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Some wands can cast more than one spell per cast",
            "Casting multiple spells at once results in their combined Cast Delay being applied",
        },
        examples = {
            {"BOUNCY_ORB","BOUNCY_ORB","BOUNCY_ORB","BOUNCY_ORB","BOUNCY_ORB"},
        },
        available_actions = {
            "BOUNCY_ORB"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 3, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 0, -- cast delay in frames
                        spread_degrees = 20, -- spread
                        mana_charge_speed = 120, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
            }
        },
    },
    { name = "Wand Building Basics - Modifiers I",
        flag = "challenge_basics_modifiers_1",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 30, ROOMS.Wide, challenge ) end,
        hints = {
            "Modifier spells cast the next spell in the wand automatically",
            "Modifier spells are applied to projectile spells in the same cast",
        },
        examples = {
            {"DAMAGE","DAMAGE","DAMAGE","BOUNCY_ORB"},
        },
        available_actions = {
            "BOUNCY_ORB",
            "DAMAGE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 30, -- mana charge speed
                        mana_max = 100, -- mana max
                    }
                },
            }
        }
    },
    { name = "Wand Building Basics - Modifiers II",
        flag = "challenge_basics_modifiers_1",
        description = "Deal 60 or more damage per second to the target dummy",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 60, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Some modifiers can be used to greatly improve some stats at the expensive of others",
        },
        examples = {
            {"HEAVY_SPREAD","HEAVY_SPREAD","HEAVY_SPREAD","BOUNCY_ORB"},
        },
        available_actions = {
            "BOUNCY_ORB",
            "HEAVY_SPREAD",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 200, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Wand Building Basics - Multicast I",
        flag = "challenge_basics_multicast_1",
        description = "Deal 70 or more damage per second to the target dummy",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 70, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "You can use multicast spells to cast more than one projectile spell at a time",
            "This can be paired with spells that have a negative Cast Delay to increase damage per second",
            "Place one or more multicast spells before two or more projectile spells",
        },
        examples = {
            {"BURST_3","SPITTER","SPITTER","SPITTER"},
            {"BURST_4","LIGHT_BULLET","BUBBLESHOT","ARROW","SPITTER"},
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW",
            "BURST_2","BURST_3","BURST_4","SCATTER_2","SCATTER_3","SCATTER_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 18, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
            }
        }
    },
    { name = "Wand Building Basics - Multicast II",
        flag = "challenge_basics_multicast_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 70, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Multicast spells use one of their casts casting the next multicast spell",
            "As such, two double multicasts is not equivalent to one quadruple multicast",
        },
        examples = {
            {"SCATTER_2","SCATTER_2","SCATTER_2","SCATTER_2","SPITTER","SPITTER","SPITTER","SPITTER","SPITTER"},
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW",
            "SCATTER_2","BURST_2",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 9, -- capacity
                        reload_time = 25, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    }
                },
            }
        }
    },
    { name = "Wand Building Basics - Multicast III",
        flag = "challenge_basics_multicast_3",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 550, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Multicasting a single modifier with many projectiles can cost much less than using multiple modifiers",
            "This is particularly effective for expensive modifiers with unique effects",
        },
        examples = {
        },
        available_actions = {
            "TENTACLE",
            "AREA_DAMAGE",
            "BURST_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 9, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 12, -- cast delay in frames
                        spread_degrees = 10, -- spread
                        mana_charge_speed = 70, -- mana charge speed
                        mana_max = 180, -- mana max
                    },
                },
            }
        }
    },
    { name = "Wand Building Basics - Cast State",
        flag = "challenge_basics_cast_state",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 500, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "The Cast State is a list of the modifications your spells have made to the cast",
            "Most modifier spells affect the Cast State",
            "The modifications in the Cast State are applied to all of the spells in the cast at the end",
            "Because modifications are applied last, the order of modifiers generally doesn't matter",
        },
        examples = {
            {"DAMAGE","DAMAGE","DAMAGE","DAMAGE","DAMAGE","BURST_4","LIGHT_BULLET","LIGHT_BULLET","LIGHT_BULLET","LIGHT_BULLET"},
            {"BURST_4","DAMAGE","DAMAGE","DAMAGE","DAMAGE","DAMAGE","LIGHT_BULLET","LIGHT_BULLET","LIGHT_BULLET","LIGHT_BULLET"},
            {"DAMAGE","BURST_4","LIGHT_BULLET","LIGHT_BULLET","DAMAGE","LIGHT_BULLET","DAMAGE","DAMAGE","DAMAGE","LIGHT_BULLET"},
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","SPITTER","ARROW",
            "BURST_2","BURST_3","BURST_4","SCATTER_2","SCATTER_3","SCATTER_4",
            "DAMAGE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 10, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 75, -- mana charge speed
                        mana_max = 300, -- mana max
                    }
                },
            }
        }
    },
    { name = "Always Cast - Introduction I",
        flag = "challenge_always_cast_1",
        preprocessor_callback = function( challenge ) total_damage_challenge( 200, ROOMS.Wide, challenge ); end,
        hints = {
            "Wands may have permanently attached Always Cast spells",
            "Always Cast spells are cast immediately before every normal cast, even if that cast is no spell",
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","BOUNCY_ORB","SPITTER"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = true, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    },
                    actions = {
                        { {action = "LIGHT_BULLET", permanent = true, locked = true} },
                    }
                },
            }
        }
    },
    { name = "Always Cast - Introduction II",
        flag = "challenge_always_cast_2",
        preprocessor_callback = function( challenge ) total_damage_challenge( 500, ROOMS.Wide, challenge ); end,
        hints = {
            "Always Cast spells are cast immediately before every normal cast, even if that cast is no spell",
            "Because of this, all casts on a wand will receive an Always Cast modifier",
        },
        available_actions = {
            "BUBBLESHOT","LIGHT_BULLET","BOUNCY_ORB","SPITTER"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = true, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 50, -- mana charge speed
                        mana_max = 200, -- mana max
                    },
                    actions = {
                        { {action = "DAMAGE", permanent = true, locked = true} },
                    }
                },
            }
        }
    },
    { name = "Always Cast - Introduction III",
        flag = "challenge_always_cast_3",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 400, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Always Cast spells do not consume mana, but do apply their Cast Delay",
        },
        available_actions = {
            "ROCKET",
            "RECHARGE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 8, -- recharge time in frames
                        fire_rate_wait = 8, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 120, -- mana charge speed
                        mana_max = 60, -- mana max
                    }
                },
            }
        }
    },
    { name = "Always Cast - Multicast I",
        flag = "challenge_always_cast_multicast_1",
        description = "Deal 230 or more damage per second to the target dummy using only 1 Always Cast spell",
        hints = {
            "Because Always Casts are extra casts on your wand, normal casts still occur",
            "This results in a multicast Always Cast allowing you to cast an additional spell",
        },
        available_actions = {
            "FIREBOMB","BURST_2"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 10, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 2, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 200, -- mana max
                    },
                    actions = {
                    }
                },
            }
        },
        data = {
            highest_dps = 0,
            always_cast_count = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_highest_dps","0");
            challenge.data.highest_dps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_wide/init.xml', x, y );

            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x + 160, y + 10 );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            

            local light = EntityLoad( "mods/spell_lab/files/entities/area_light.xml", x + 90, y );
            EntityAddTag( light, "spell_lab_challenge_cleanup" );

            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local highest_dps = tonumber( GlobalsGetValue("spell_lab_highest_dps","0") );
            if highest_dps > challenge.data.highest_dps then
                challenge.data.highest_dps = highest_dps;
            end
            local held_wand = get_entity_held_or_random_wand( player_entity );
            if held_wand then
                local _,permanent_actions = wand_get_actions_absolute( held_wand );
                challenge.data.always_cast_count = #permanent_actions;
            end
            if challenge.data.always_cast_count > 1 then
                GlobalsSetValue("spell_lab_highest_dps","0");
                challenge.data.highest_dps = 0;
            end
            return challenge.data.highest_dps >= 230 and challenge.data.always_cast_count <= 1;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Use at most 1 Always Cast spell - "..(challenge.data.always_cast_count ).."/1",
                "Highest Damage Per Second - "..( math.floor( challenge.data.highest_dps * 100 ) / 100 ).."/230"
            };
        end
    },
    --[[{ name = "Always Cast - Multicast II",
        flag = "challenge_always_cast_multicast_2",
        description = "Deal 230 or more damage per second to the target dummy using only 1 Always Cast spell",
        hints = {
            "Because Always Casts are extra casts on your wand, normal casts still occur",
            "This results in a multicast Always Cast allowing you to cast an additional spell",
        },
        available_actions = {
            "FIREBOMB","BURST_2"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 10, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 2, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 200, -- mana max
                    },
                    actions = {
                    }
                },
            }
        },
        data = {
            highest_dps = 0,
            always_cast_count = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_highest_dps","0");
            challenge.data.highest_dps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_wide/init.xml', x, y );

            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x + 160, y + 10 );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            

            local light = EntityLoad( "mods/spell_lab/files/entities/area_light.xml", x + 90, y );
            EntityAddTag( light, "spell_lab_challenge_cleanup" );

            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local highest_dps = tonumber( GlobalsGetValue("spell_lab_highest_dps","0") );
            if highest_dps > challenge.data.highest_dps then
                challenge.data.highest_dps = highest_dps;
            end
            local held_wand = get_entity_held_or_random_wand( player_entity );
            if held_wand then
                local _,permanent_actions = wand_get_actions_absolute( held_wand );
                challenge.data.always_cast_count = #permanent_actions;
            end
            if challenge.data.always_cast_count > 1 then
                GlobalsSetValue("spell_lab_highest_dps","0");
                challenge.data.highest_dps = 0;
            end
            return challenge.data.highest_dps >= 230 and challenge.data.always_cast_count <= 1;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Use at most 1 Always Cast spell - "..(challenge.data.always_cast_count ).."/1",
                "Highest Damage Per Second - "..( math.floor( challenge.data.highest_dps * 100 ) / 100 ).."/230"
            };
        end
    },]]
    { name = "Damage Every x Frames - Introduction",
        flag = "challenge_tick_damage",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 100, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Inert static projectiles can be given the ability to deal damage",
            "The centre point of a static projectile must collide with a target to deal damage",
            "Homing and Damage can be paired with static projectiles to make a homing familiar"
        },
        available_actions = {
            "MIST_SLIME","MIST_ALCOHOL",
            "HOMING","DAMAGE","ELECTRIC_CHARGE","LINE_ARC","HORIZONTAL_ARC"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Damage Every x Frames - Drilling Shot",
        flag = "challenge_tick_damage_drilling_shot",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 100, 60, ROOMS.Prison, challenge ); end,
        hints = {
            "Drilling Shot allows projectiles to travel through walls",
            "Drilling Shot activates on the second frame of a projectile's life",
            "Projectiles with higher lifetimes are generally more useful as homing familiars"
        },
        available_actions = {
            "MIST_SLIME","MIST_ALCOHOL",
            "HOMING","DAMAGE","FREEZE","ELECTRIC_CHARGE","CLIPPING_SHOT","ACCELERATING_SHOT"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Damage Every x Frames - Special Projectiles",
        flag = "challenge_tick_damage_special",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 1000, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Different projectiles have different tick damage rates",
            "Ocarina and Kantele notes deal their damage every frame, but have low lifetime",
        },
        examples = {
            {"HOMING","LIFETIME","DAMAGE","OCARINA_A"},
        },
        available_actions = {
            "MIST_SLIME","MIST_ALCOHOL","OCARINA_A","KANTELE_A",
            "HOMING","DAMAGE","FREEZE","ELECTRIC_CHARGE","LIFETIME"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Damage Every x Frames - Piercing Shot",
        flag = "challenge_tick_damage_piercing_shot",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 1500, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Most non-static projectiles deal their damage every frame, but die upon collision",
            "Piercing Shot allows projectiles to keep living even if they collide with something",
            "Piercing Shot actives on the second frame of a projectiles lifetime"
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","LANCE","SPITTER_TIER_3",
            "HOMING","HOMING_ROTATE","ACCELERATING_SHOT","LIFETIME","PIERCING_SHOT",
            "SCATTER_2","SCATTER_3","SCATTER_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 400, -- mana charge speed
                        mana_max = 800, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Introduction",
        flag = "challenge_trigger_basic",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 60, ROOMS.Split, challenge ); end,
        hints = {
            "Trigger spells cast another spell when a certain condition is met",
            "Trigger Hit spells cast another spell when they hit the world or an object",
            "Accurate, easy to control trigger spells can be used as delivery mechanisms for slow, awkward, or static spells",
        },
        available_actions = {"LIGHT_BULLET_TRIGGER","LIGHT_BULLET_TIMER","LIGHT_BULLET_TRIGGER_2","DEATH_CROSS","GRENADE_LARGE","GRENADE","EXPLOSION"},
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Cast State",
        flag = "challenge_trigger_cast_state",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 300, 60, ROOMS.Split, challenge ); end,
        hints = {
            "Trigger spells have their own cast state which is discarded after the cast",
            "Because of this, modifer spells applied inside a trigger generally don't persist outside the trigger",
            "Unlike Recharge Time, Cast Delay is applied per cast state, so changes to it can be discarded",
            "You can negate a spell's Cast Delay changes by casting it inside of a trigger",
        },
        available_actions = {
            "LIGHT_BULLET_TRIGGER","LIGHT_BULLET_TIMER","DEATH_CROSS","GRENADE_LARGE","GRENADE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Multicast I",
        flag = "challenge_trigger_multicast_1",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 750, 60, ROOMS.Split, challenge ); end,
        hints = {
            "Trigger spells can cast multiple spells directly inside the enemy",
            "Powerful spells tend to have high Cast Delay (which can be negated using triggers)",
        },
        available_actions = {
            "LANCE","DISC_BULLET","DISC_BULLET_BIG","SLIMEBALL",
            "LIGHT_BULLET_TRIGGER",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 6, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Multicast II",
        flag = "challenge_trigger_multicast_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 750, 60, ROOMS.Split, challenge ); end,
        hints = {
            "Modifiers can be applied to triggered multicasts",
        },
        examples = {
            {"LIGHT_BULLET_TRIGGER","DAMAGE","DAMAGE","DAMAGE","DAMAGE","CIRCLE_SHAPE","LANCE","LANCE","LANCE","LANCE","LANCE","LANCE"}
        },
        available_actions = {
            "LANCE",
            "LIGHT_BULLET_TRIGGER",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "DAMAGE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 12, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Negating Modifier Effects",
        flag = "challenge_trigger_modifiers",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 4000, 60, ROOMS.Split, challenge ); end,
        hints = {
            "Triggers can negate some negative effects of some modifiers",
            "Stacking Heavy Shots can lead to very powerful but slow shots",
            "Heavy Spread's Recharge Time reduction is not discarded with the cast state",
        },
        available_actions = {
            "BUBBLESHOT",
            "LIGHT_BULLET_TRIGGER",
            "PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "HEAVY_SHOT","HEAVY_SPREAD","RECOIL_DAMPER"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 12, -- capacity
                        reload_time = 15, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 500, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Trigger Modifiers",
        flag = "challenge_trigger_custom_triggers",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 1000, 60, ROOMS.Split, challenge ); end,
        hints = {
            "The Add Trigger Modifier spell can make any projectile a trigger hit type projectile",
            "The Add Timer Modifier spell can make any projectile a trigger timer type projectile",
            "The Add Expiration Trigger Modifier spell can make any projectile a trigger death type projectile",
            "Trigger modifiers act somewhat differently to natural trigger spells",
        },
        available_actions = {
            "LIGHT_BULLET","BULLET","HEAVY_BULLET","LANCE","LASER","ARROW","EXPLOSION","GRENADE","DEATH_CROSS",
            "PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "ADD_TRIGGER","ADD_TIMER","ADD_DEATH_TRIGGER" },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 9, -- capacity
                        reload_time = 10, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 500, -- mana charge speed
                        mana_max = 1250, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Repeat",
        flag = "challenge_trigger_repeat",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 800, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Hit type triggers can be retriggered if the projectile is one that does not die on collision",
            "Piercing Shot keeps a projectile alive even after it collides with something",
            "A projectile can't retrigger if it has collided with the world",
            "Piercing Shot enables you to retrigger trigger hit type spells multiple times",
            "A slow, homing, high lifetime trigger hit type spell will allow you to retrigger effectively",
        },
        available_actions = {
            "HEAVY_BULLET",
            "LIGHT_BULLET_TRIGGER","BUBBLESHOT_TRIGGER",
            "PIERCING_SHOT", "HOMING_ROTATE", "DECELERATING_SHOT" },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 200, -- mana charge speed
                        mana_max = 700, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Challenge I",
        flag = "challenge_trigger_challenge_1",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 100000, 60, ROOMS.Split, challenge ); end,
        challenge = true,
        hints = {
            "Piercing Shot actives on the second frame of a projectiles lifetime"
        },
        available_actions = {
            "BUBBLESHOT","SPITTER",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "LIGHT_BULLET_TRIGGER","BUBBLESHOT_TRIGGER","ADD_TRIGGER","ADD_TIMER","ADD_DEATH_TRIGGER",
            "PIERCING_SHOT", "HOMING_ROTATE", "HOMING",
            "DAMAGE","HEAVY_SHOT"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 16, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 1000, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },
    { name = "Trigger Spells - Challenge II",
        flag = "challenge_trigger_challenge_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 1000000, 60, ROOMS.Split, challenge ); end,
        challenge = true,
        hints = {
            "Piercing Shot actives on the second frame of a projectiles lifetime"
        },
        available_actions = {
            "LIGHT_BULLET","BUBBLESHOT","LANCE",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "LIGHT_BULLET_TRIGGER","BUBBLESHOT_TRIGGER","ADD_TRIGGER","ADD_TIMER","ADD_DEATH_TRIGGER",
            "PIERCING_SHOT", "HOMING_ROTATE", "HOMING", "LONG_DISTANCE_CAST","DAMAGE","HEAVY_SHOT"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 16, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 1000, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },





    { name = "Casting Speed - Review",
        flag = "challenge_casting_speed_basic",
        description = "Fire 6 projectiles a second",
        hints = {
            "The Cast Delay of the wand is also applied to every cast",
            "Cast Delay is applied between every cast including the last cast, after which the wand needs to reload",
            "Recharge Time is applied when your wand is out of casts",
            "Wands with high Recharge Time and low Cast Delay can fire rapidly with enough separate projectiles",
        },
        available_actions = {"LIGHT_BULLET","BULLET","HEAVY_BULLET"},
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 12, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 5, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 200, -- mana charge speed
                        mana_max = 300, -- mana max
                    }
                },
            }
        },
        data = {
            highest_projectiles_per_second = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_projectiles_per_second","0");
            challenge.data.highest_projectiles_per_second = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );

            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x, y );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local projectiles_per_second = tonumber( GlobalsGetValue("spell_lab_projectiles_per_second","0") );
            if projectiles_per_second > challenge.data.highest_projectiles_per_second then
                challenge.data.highest_projectiles_per_second = projectiles_per_second;
            end
            return challenge.data.highest_projectiles_per_second >= 6;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Projectiles Per Second Reached - "..challenge.data.highest_projectiles_per_second.."/6"
            };
        end
    },
    { name = "Casting Speed - Special Projectiles",
        flag = "challenge_casting_speed_special_projectiles",
        description = "Fire 20 projectiles a second",
        hints = {
            "Certain projectile spells have Cast Delay and Recharge Time reductions",
            "Casting spells that reduce Recharge Time affect the final reload time of the wand",
            "Casting spells that reduce Cast Delay can decrease the time it takes to cast the next spell",
        },
        available_actions = {
        "LIGHT_BULLET","BUBBLESHOT","RUBBER_BALL","LASER",
        "DIGGER","POWERDIGGER","LUMINOUS_DRILL"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 6, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 15, -- cast delay in frames
                        spread_degrees = 5, -- spread
                        mana_charge_speed = 400, -- mana charge speed
                        mana_max = 600, -- mana max
                    }
                },
            }
        },
        data = {
            highest_projectiles_per_second = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_projectiles_per_second","0");
            challenge.data.highest_projectiles_per_second = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );

            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x, y );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local projectiles_per_second = tonumber( GlobalsGetValue("spell_lab_projectiles_per_second","0") );
            if projectiles_per_second > challenge.data.highest_projectiles_per_second then
                challenge.data.highest_projectiles_per_second = projectiles_per_second;
            end
            return challenge.data.highest_projectiles_per_second >= 20;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Projectiles Per Second Reached - "..challenge.data.highest_projectiles_per_second.."/20"
            };
        end
    },
    { name = "Casting Speed - Chainsaw",
        flag = "challenge_casting_speed_chainsaw",
        description = "Fire 50 projectiles a second",
        hints = {
            "Chainsaw reduces Cast Delay to 0 when it is cast",
            "Chainsaw also reduces Recharge Time",
            "The placement of the Chainsaw spell is important for negating Cast Delay",
            "Since Chainsaw sets Cast Delay to 0 instead of reducing it, putting Chainsaw at the end will negate Cast Delay",
        },
        available_actions = {
            "CHAINSAW","LIGHT_BULLET"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 31, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 500, -- mana charge speed
                        mana_max = 1000, -- mana max
                    },
                    actions = {
                        { {action = "BURST_3", locked = true} },
                        { {action = "LIGHT_BULLET", locked = true} }
                    }
                },
            }
        },
        data = {
            highest_projectiles_per_second = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_projectiles_per_second","0");
            challenge.data.highest_projectiles_per_second = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );

            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x, y );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local projectiles_per_second = tonumber( GlobalsGetValue("spell_lab_projectiles_per_second","0") );
            if projectiles_per_second > challenge.data.highest_projectiles_per_second then
                challenge.data.highest_projectiles_per_second = projectiles_per_second;
            end
            return challenge.data.highest_projectiles_per_second >= 50;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Projectiles Per Second Reached - "..challenge.data.highest_projectiles_per_second.."/50"
            };
        end
    },
    { name = "Critical Chance - Introduction",
        flag = "challenge_critical_basic",
        description = "Hit the target dummy with a 15% or higher critical chance projectile",
        hints = {
            "There are no individual projectiles with a 15% critical chance",
            "Projectile spells add their critical chance to the cast state",
            "The critical chance of the cast state is applied to each projectile at the end of the cast",
            "Multicasting 2 Sparkbolts results in firing 2 Sparkbolts each with a 10% chance of a critical hit",
        },
        available_actions = {
            "LIGHT_BULLET","BULLET","HEAVY_BULLET",
            "BURST_2","BURST_3","BURST_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 150, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    }
                },
            },
            potions = {
                { { {"blood", 1000} } }, -- a list of random choices of material amount pairs
            },
            perks = {}
        },
        data = {
            highest_crit_chance = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_highest_crit_chance","0");
            challenge.data.highest_crit_chance = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );

            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x, y );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local highest_crit_chance = tonumber( GlobalsGetValue("spell_lab_highest_crit_chance","0") );
            if highest_crit_chance > challenge.data.highest_crit_chance then
                challenge.data.highest_crit_chance = highest_crit_chance;
            end
            return challenge.data.highest_crit_chance >= 15;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Hit the dummy with a 15% Critical Chance projectile - "..challenge.data.highest_crit_chance.."%/15%"
            };
        end
    },
    { name = "Critical Chance - Blood",
        flag = "challenge_blood_critical",
        description = "Hit the target dummy with a 50% or higher critical chance projectile",
        hints = {
            "Being bloody increases your chance of a critical strike by 5% or more",
            "The 5% critical hit chance bonus from being bloody is applied for each projectile spell in the cast",
            "Multicasting 3 Sparkbolts while bloody results in 3 Sparkbolts each with a 30% chance of a critical hit",
        },
        available_actions = {"LIGHT_BULLET","BULLET","HEAVY_BULLET","BURST_2","BURST_3","BURST_4","MATERIAL_BLOOD","MIST_BLOOD"},
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 150, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    }
                },
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 100, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                        {"MIST_BLOOD"}
                    }
                },
            },
            potions = {
                { { {"blood", 1000} } }, -- a list of random choices of material amount pairs
            },
            perks = {}
        },
        data = {
            highest_crit_chance = 0
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_highest_crit_chance","0");
            challenge.data.highest_crit_chance = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );

            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x, y );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local highest_crit_chance = tonumber( GlobalsGetValue("spell_lab_highest_crit_chance","0") );
            if highest_crit_chance > challenge.data.highest_crit_chance then
                challenge.data.highest_crit_chance = highest_crit_chance;
            end
            return challenge.data.highest_crit_chance >= 50;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Critical Chance Reached - "..challenge.data.highest_crit_chance.."%/50%"
            };
        end
    },
    { name = "Critical Chance - Sharing Critical Chance",
        flag = "challenge_critical_multicast",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 150, ROOMS.Small, challenge ); end,
        hints = {
            "Casting a projectile that adds critical chance applies that chance to the cast state",
            "Multicasting any spell with a chance to critically hit allows all spells in the cast to critically hit",
        },
        available_actions = {
            "LIGHT_BULLET","LANCE",
            "CIRCLE_SHAPE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 7, -- capacity
                        reload_time = 10, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 150, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {}
                }
            },
            potions = {},
            perks = {}
        }
    },
    { name = "Critical Chance - Crit On X Spells",
        flag = "challenge_critical_hitfx",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 400, 60, ROOMS.Small, challenge ); end,
        hints = {
            "Critical on X modifier spells add a 100% critical hit chance when they activate",
            "Critical on X modifier spells stack with all other forms of critical hit chance (even themselves)",
            "A projectile modified with Burning Trail applies 12 seconds of the On Fire status effect to the target",
        },
        available_actions = {
            "DISC_BULLET",
            "HITFX_BURNING_CRITICAL_HIT","BURN_TRAIL",
            "MATERIAL_BLOOD","MIST_BLOOD"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 8, -- recharge time in frames
                        fire_rate_wait = 8, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 150, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {}
                },
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 100, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                        {"MIST_BLOOD"}
                    }
                },
            },
            potions = {},
            perks = {}
        }
    },
    { name = "Critical Chance - Critical Chance Overflow",
        flag = "challenge_critical_overflow",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 500, ROOMS.Small, challenge ); end,
        hints = {
            "If a projectile has over a 100% chance to critically hit, the extra percent is applied as extra critical damage",
            "Critical on X modifier spells add a 100% critical hit chance when they activate",
            "Critical on X modifier spells stack with all other forms of critical hit chance (even themselves)",
        },
        available_actions = {
            "DISC_BULLET",
            "HITFX_BURNING_CRITICAL_HIT","BURN_TRAIL",
            "MATERIAL_BLOOD","MIST_BLOOD"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 10, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 150, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {}
                },
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 30, -- recharge time in frames
                        fire_rate_wait = 30, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 100, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                        {"MIST_BLOOD"}
                    }
                },
            },
            potions = {},
            perks = {}
        }
    },




    { name = "Spell Wrap - Introduction",
        flag = "challenge_spell_wrap",
        description = "Perform a spell wrap 5 times",
        hints = {
            "A spell wrap occurs when a spell attempts to cast another spell but there are no spells left to cast",
            "Spell wrapping allows you to cast spells that have already been cast before a reload makes them available again",
            "The wand will always properly reload immediately after a spell wrap",
            "A proper spell wrap requires a spell to have previously been cast",
        },
        available_actions = {
            "LIGHT_BULLET",
            "BURST_2"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 2, -- capacity
                        reload_time = 40, -- recharge time in frames
                        fire_rate_wait = 2, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        },
        data = {
            spell_wraps = 0
        },
        initialization_callback = function( challenge, player_entity )
            challenge.data.spell_wraps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local last_spell_wrap_frame = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_frame", 0 ) );
            if GameGetFrameNum() == last_spell_wrap_frame then
                challenge.data.spell_wraps = challenge.data.spell_wraps + 1;
            end
            return challenge.data.spell_wraps >= 5;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Perform a spell wrap "..challenge.data.spell_wraps.."/5"
            };
        end
    },
    { name = "Spell Wrap - Modifiers",
        flag = "challenge_spell_wrap_modifiers",
        description = "Perform a spell wrap 5 times",
        hints = {
            "Modifiers generally attempt to cast the spell after them",
            "Since modifiers attempt to cast the next spell, they can be used to spell wrap",
        },
        available_actions = {
            "LIGHT_BULLET",
            "DAMAGE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 4, -- capacity
                        reload_time = 40, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        },
        data = {
            spell_wraps = 0
        },
        initialization_callback = function( challenge, player_entity )
            challenge.data.spell_wraps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local last_spell_wrap_frame = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_frame", 0 ) );
            if GameGetFrameNum() == last_spell_wrap_frame then
                challenge.data.spell_wraps = challenge.data.spell_wraps + 1;
            end
            return challenge.data.spell_wraps >= 5;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Perform a spell wrap "..challenge.data.spell_wraps.."/5"
            };
        end
    },
    { name = "Spell Wrap - Triggers",
        flag = "challenge_spell_wrap_triggers",
        description = "Perform a spell wrap 5 times",
        hints = {
            "Trigger spells attempt to cast the next spell and as such can be used to spell wrap",
        },
        available_actions = {
            "LIGHT_BULLET_TRIGGER","BUBBLESHOT",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 4, -- capacity
                        reload_time = 40, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        },
        data = {
            spell_wraps = 0
        },
        initialization_callback = function( challenge, player_entity )
            challenge.data.spell_wraps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local last_spell_wrap_frame = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_frame", 0 ) );
            if GameGetFrameNum() == last_spell_wrap_frame then
                challenge.data.spell_wraps = challenge.data.spell_wraps + 1;
            end
            return challenge.data.spell_wraps >= 5;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Perform a spell wrap "..challenge.data.spell_wraps.."/5"
            };
        end
    },
    { name = "Spell Wrap - Multicast I",
        flag = "challenge_spell_wrap_multicast_1",
        description = "Perform a spell wrap with at least 3 spells 5 times",
        hints = {
            "A multicast at the end can spell wrap to multiple spells",
            "Spell wrapping can allow you to cast your spells twice before a reload is forced",
        },
        available_actions = {
            "BUBBLESHOT",
            "BURST_3"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 4, -- capacity
                        reload_time = 90, -- recharge time in frames
                        fire_rate_wait = 22, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        },
        data = {
            spell_wraps = 0
        },
        initialization_callback = function( challenge, player_entity )
            challenge.data.spell_wraps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local last_spell_wrap_frame = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_frame", 0 ) );
            if GameGetFrameNum() == last_spell_wrap_frame then
                local last_spell_wrap_amount = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_amount", 0 ) );
                if last_spell_wrap_amount >= 3 then
                    challenge.data.spell_wraps = challenge.data.spell_wraps + 1;
                end
            end
            return challenge.data.spell_wraps >= 5;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Perform a spell wrap that casts 3 spells at once - "..challenge.data.spell_wraps.."/5"
            };
        end
    },

    { name = "Spell Wrap - Multicast II",
        flag = "challenge_spell_wrap_multicast_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 35, 60, ROOMS.Small, challenge ); end,
        hints = {
            "You can perform a spell wrap into a multicast",
            "Spell wrapping can allow you to cast your spells twice before a reload is forced",
        },
        available_actions = {
            "BUBBLESHOT",
            "BURST_2","BURST_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 6, -- capacity
                        reload_time = 90, -- recharge time in frames
                        fire_rate_wait = 22, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        }
    },
    { name = "Spell Wrap - Spells Per Cast",
        flag = "challenge_spell_wrap_spell_per_cast",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 45, 60, ROOMS.Small, challenge ); end,
        hints = {
            "The wand's Spells Per Cast is also applied when spell wrapping",
            "Spells Per Cast doesn't spell wrap on its own",
        },
        available_actions = {
            "BUBBLESHOT",
            "BURST_2"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 5, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 6, -- capacity
                        reload_time = 90, -- recharge time in frames
                        fire_rate_wait = 22, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        }
    },


    { name = "Spell Wrap - Chainsaw I",
        flag = "challenge_spell_wrap_chainsaw_1",
        description = "Cast a spell with a final recharge time of 0 seconds using only 1 Chainsaw",
        hints = {
            "Chainsaw reduces Recharge Time by ~0.17 seconds",
            "Spell wrapping allows you to apply the effects of each Chainsaw twice",
            "When a wand runs out of spells to cast, it takes the current Recharge Time to reload",
        },
        available_actions = {
            "CHAINSAW",
            "BURST_2",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 2, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        wand_set_stat( wand, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        },
        data = {
            last_recharge_time = 100,
            chainsaws_on_wand = 0,
            spell_wraps = 0,
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue( "spell_lab_last_recharge_time", "100" );
            challenge.data.last_recharge_time = 100;
            challenge.data.spell_wraps = 0;

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_small/init.xml', x, y );
            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            local success = true;

            local last_spell_wrap_frame = tonumber( GlobalsGetValue("spell_lab_last_spell_wrap_frame", 0 ) );
            if GameGetFrameNum() == last_spell_wrap_frame then
                challenge.data.spell_wraps = challenge.data.spell_wraps + 1;
            end
            
            local chainsaws_on_wand = 0;
            local held_wand = get_entity_held_or_random_wand( player_entity );
            for k,v in pairs( wand_get_actions_absolute( held_wand ) or {} ) do
                if v.action_id == "CHAINSAW" then
                    chainsaws_on_wand = chainsaws_on_wand + 1;
                end
            end
            challenge.data.chainsaws_on_wand = chainsaws_on_wand;
            if tonumber( GlobalsGetValue( "spell_lab_last_recharge_time", "10" ) ) > 0 or
                challenge.data.chainsaws_on_wand ~= 1 or
                tonumber( GlobalsGetValue( "spell_lab_last_cast_frame", "0" ) ) ~= GameGetFrameNum() or
                challenge.data.spell_wraps < 60
            then
                success = false;
            end
            return success;
        end,
        progress_callback = function( challenge, player_entity )
            local last_recharge_time = tonumber( GlobalsGetValue( "spell_lab_last_recharge_time", "100" ) );
            challenge.data.last_recharge_time = last_recharge_time;
            return {
                "Cast a spell with 0 seconds of Recharge Time - "..( math.floor( ( challenge.data.last_recharge_time / 60 ) * 100 ) / 100 ).." seconds",
                "Use only 1 Chainsaw - "..( challenge.data.chainsaws_on_wand ).."/1 Chainsaws",
                "Spell Wrap - "..( challenge.data.spell_wraps ).."/60 times",
            };
        end
    },
    { name = "Spell Wrap - Chainsaw II",
        flag = "challenge_spell_wrap_chainsaw_2",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 90, 60, ROOMS.Small, challenge ); end,
        hints = {
            "Combining multicast and spell wrap with a Chainsaw can result in extreme rapid fire",
            "The Chainsaw's Recharge Time reduction can be applied twice by spell wrapping it",
        },
        available_actions = {
            "LIGHT_BULLET","CHAINSAW",
            "BURST_2"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 3, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 300, -- mana max
                    }
                },
            }
        }
    },
    { name = "Spell Wrap - Chainsaw III",
        flag = "challenge_spell_wrap_chainsaw_3",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 75, 60, ROOMS.Small, challenge ); end,
        hints = {
            "Multicasting spell wrapped chainsaws can result in major reductions to recharge time",
            "You can only spell wrap to spells you've already cast"
        },
        available_actions = {
            "CHAINSAW","LIGHT_BULLET",
            "BURST_2","BURST_3","BURST_4"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 9, -- capacity
                        reload_time = 90, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 300, -- mana charge speed
                        mana_max = 1000, -- mana max
                    },
                    stat_randoms = {},
                    permanent_actions = {},
                    actions = {
                    },
                    callback = function( wand, ability )
                        ability_component_set_stat( ability, "mana", 0 );
                    end
                },
            },
            actions = {},
            potions = {},
            perks = {}
        }
    },


    { name = "Explosion Damage - Introduction",
        flag = "challenge_explosion_damage",
        description = "Deal (almost) exactly 105 explosion damage in one hit to the target dummy",
        hints = {
            "Explosion damage is inaccurate and misleading",
            "Explosion damage is roughly 4x (400%) exaggerated on spell cards (explosions deal 25% of what is stated)",
        },
        available_actions = {
            "ROCKET","ROCKET_TIER_2","ROCKET_TIER_3","GRENADE","GRENADE_LARGE","EXPLOSION"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 10, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 200, -- mana charge speed
                        mana_max = 300, -- mana max
                    },
                    actions = {
                        {{action="LIGHT_SHOT",locked=true}},
                        {{action="LIGHT_SHOT",locked=true}},
                        {{action="LIGHT_SHOT",locked=true}},
                        {{action="LIGHT_SHOT",locked=true}},
                        {{action="LIGHT_SHOT",locked=true}},
                        {{action="LIGHT_SHOT",locked=true}},
                    }
                },
            }
        },
        initialization_callback = function( challenge, player_entity )
            GlobalsSetValue("spell_lab_latest_damage","0");

            EntityApplyTransform( player_entity, 14600, -7000 );
            local x, y = EntityGetTransform( player_entity );
            GameSetCameraPos( x, y );
            load_pixel_scene( 'mods/spell_lab/files/biome_impl/challenge_split/init.xml', x, y );

            local dummy = EntityLoad( "mods/spell_lab/files/entities/dummy_target/dummy_target.xml", x + 160, y + 10 );
            EntityAddTag( dummy, "spell_lab_challenge_cleanup" );
            

            local light = EntityLoad( "mods/spell_lab/files/entities/area_light.xml", x + 90, y );
            EntityAddTag( light, "spell_lab_challenge_cleanup" );

            handle_loadout( player_entity, challenge.loadout );
        end,
        validation_callback = function( challenge, player_entity )
            return math.floor( tonumber( GlobalsGetValue("spell_lab_latest_damage","0") ) + 0.5 ) == 105;
        end,
        progress_callback = function( challenge, player_entity )
            return {
                "Deal 105 explosion damage - "..math.floor( tonumber( GlobalsGetValue("spell_lab_latest_damage","0") ) + 0.5).."/105"
            };
        end
    },
    { name = "Explosion Damage - Radius Based Damage",
        flag = "challenge_explosion_damage_radius",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 300, ROOMS.Small, challenge ); end,
        hints = {
            "Modifiers that increase Explosion Radius can drastically increase a projectile's explosion damage",
            "Two or more Explosive Projectile modifiers applied to almost any spell activates this buggy behaviour",
        },
        available_actions = {
            "LIGHT_BULLET","BULLET","BUBBLESHOT","BUCKSHOT","AIR_BULLET",
            "EXPLOSIVE_PROJECTILE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    }
                },
            }
        }
    },
    { name = "Explosion Damage - Special Projectiles",
        flag = "challenge_explosion_damage_special",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 300, ROOMS.Small, challenge ); end,
        hints = {
            "Certain projectiles are lacking explosion definitions and instead default to unstable parameters",
            "These particular projectiles only need a single Explosive Projectile to activate the buggy behaviour",
        },
        available_actions = {
            "RUBBER_BALL","ARROW","DISC_BULLET","DISC_BULLET_BIG",
            "EXPLOSIVE_PROJECTILE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 2, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 100, -- mana charge speed
                        mana_max = 300, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Introduction",
        flag = "challenge_velocity_damage",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 100, ROOMS.Small, challenge ); end,
        hints = {
            "Some spells do more damage based on how fast they're moving",
            "Velocity damage is based on the discrepancy between their starting velocity and their impact velocity",
            "Only projectile type damage is scaled (slice damage, for example, is not)"
        },
        available_actions = {
            "RUBBER_BALL","INFESTATION","BOUNCY_ORB",
            "ACCELERATING_SHOT","BOUNCE","CHAOTIC_ARC"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 5, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Balance",
        flag = "challenge_velocity_damage_balance",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 10000, ROOMS.Small, challenge ); end,
        hints = {
            "Maximum velocity damage requires maintaining a balance of speed downs and acceleration ups",
            "Slow the projectile using Heavy Shot and Accelerating Shot until it no longer fires",
            "Then add Speed Ups and Light Shots or remove Heavy Shots and Accelerating Shots until it fires again",
        },
        examples = {
            {"HEAVY_SHOT","HEAVY_SHOT","ACCELERATING_SHOT","ACCELERATING_SHOT","BOUNCE","RUBBER_BALL"}
        },
        available_actions = {
            "RUBBER_BALL","ARROW","INFESTATION","BOUNCY_ORB",
            "ACCELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT","BOUNCE",
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Gravity",
        flag = "challenge_velocity_damage_gravity",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 10000, ROOMS.Small, challenge ); end,
        hints = {
            "Gravity and Anti-gravity affect initial speed enough to keep velocity damage projectiles alive",
            "Some projectiles only require one of these modifiers, and others require two",
            "The more of these modifiers you stack, the less damage the projectile will deal",
        },
        examples = {
            {"HEAVY_SHOT","HEAVY_SHOT","HEAVY_SHOT","HEAVY_SHOT","GRAVITY","RUBBER_BALL"}
        },
        available_actions = {
            "RUBBER_BALL","ARROW","INFESTATION","BOUNCY_ORB",
            "ACCELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT","BOUNCE","GRAVITY","GRAVITY_ANTI"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Homing",
        flag = "challenge_velocity_damage_homing",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 7500, ROOMS.Wide, challenge ); end,
        hints = {
            "The Homing modifier drastically affects projectile acceleration and thus can lead to unintuitive and low velocity based damage",
            "Rotate Towards Enemies maintains speed and only changes direction, so it is predictable and consistent, which is ideal",
        },
        available_actions = {
            "RUBBER_BALL","ARROW","DISC_BULLET","BOUNCY_ORB",
            "ACCELERATING_SHOT","DECELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT",
            "HOMING","HOMING_ROTATE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Accelerative Homing",
        flag = "challenge_velocity_damage_accelerative_homing",
        preprocessor_callback = function( challenge ) single_hit_damage_challenge( 20000, ROOMS.Wide, challenge ); end,
        hints = {
            "The Accelerative Homing modifier keeps slow projectiles alive and can replace the need for Accelerating Shot",
            "However, it has a few limitations: it can not be stacked, and it must come before other forms of homing",
        },
        available_actions = {
            "RUBBER_BALL","ARROW","DISC_BULLET","BOUNCY_ORB",
            "ACCELERATING_SHOT","DECELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT",
            "HOMING","HOMING_ROTATE","HOMING_ACCELERATING"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 8, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Piercing Shot",
        flag = "challenge_velocity_damage_piercing",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 100000, 60, ROOMS.Wide, challenge ); end,
        hints = {
            "Piercing Shot allows projectiles to hit multiple times instead of once",
            "If the projectile consistently immediately dies then it may be too slowed down",
        },
        available_actions = {
            "RUBBER_BALL","ARROW","DISC_BULLET","INFESTATION","BOUNCY_ORB",
            "PIERCING_SHOT","ACCELERATING_SHOT","DECELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT","BOUNCE",
            "HOMING","HOMING_ROTATE","CHAOTIC_ARC","SINEWAVE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 10, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 20, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 250, -- mana charge speed
                        mana_max = 500, -- mana max
                    }
                },
            }
        }
    },
    { name = "Velocity Damage - Challenge",
        flag = "challenge_velocity_damage_challenge",
        description = "Deal 10,000,000 or more damage per second to the target dummy",
        preprocessor_callback = function( challenge ) damage_per_frames_challenge( 10000000, 60, ROOMS.Wide, challenge ); end,
        challenge = true,
        hints = {
            "Keeping the projectile on top of the enemy is extremely important for maximizing damage",
            "While at least one Accelerating Shot is required, prefer Heavy Shots to slow the projectile and add damage",
            "Homing type modifiers can be stacked to increase their efficacy",
            "Additional projectiles is an effective way to increase damage output",
            "There is an ideal balance of speed multiplier modifiers",
            "Shooting directly downward may help keep slow projectiles alive",
        },
        available_actions = {
            "RUBBER_BALL",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "PIERCING_SHOT","ACCELERATING_SHOT","DECELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT",
            "HOMING","HOMING_ROTATE","CHAOTIC_ARC","SINEWAVE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 17, -- capacity
                        reload_time = 60, -- recharge time in frames
                        fire_rate_wait = 60, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 1000, -- mana charge speed
                        mana_max = 1000, -- mana max
                    }
                },
            }
        }
    },
    { name = "Damage Challenge I",
        flag = "damage_challenge_1",
        description = "Deal 1,000,000,000 or more total damage to the target dummy",
        preprocessor_callback = function( challenge ) total_damage_challenge( 1000000000, ROOMS.Wide, challenge ); end,
        challenge = true,
        hints = {},
        available_actions = {
            "LIGHT_BULLET","CHAINSAW","RUBBER_BALL",
            "BURST_2","BURST_3","BURST_4","PENTAGRAM_SHAPE","CIRCLE_SHAPE",
            "PIERCING_SHOT","ACCELERATING_SHOT","SPEED","LIGHT_SHOT","HEAVY_SHOT",
            "HOMING_ROTATE"
        },
        loadout = {
            name = "Challenge", -- displayed loadout name
            description = "A loadout for a Spell Lab Challenge",
            author = "goki_dev",
            items = {},
            actions = {},
            wands = { -- wands
                {
                    name = "Wand",
                    stats = {
                        shuffle_deck_when_empty = false, -- shuffle
                        actions_per_round = 1, -- spells per cast
                        speed_multiplier = 1.0, -- projectile speed multiplier (hidden)
                        deck_capacity = 25, -- capacity
                        reload_time = 20, -- recharge time in frames
                        fire_rate_wait = 10, -- cast delay in frames
                        spread_degrees = 0, -- spread
                        mana_charge_speed = 500, -- mana charge speed
                        mana_max = 2500, -- mana max
                    }
                },
            }
        }
    },
}

for k,v in pairs( challenges ) do
    if v.preprocessor_callback then
        v:preprocessor_callback();
    end
end