local entity = GetUpdatedEntityID();
if has_2gcedge == nil then has_2gcedge = false; end
if entity and has_2gcedge ~= true and ModSettingGet("spell_lab.force_2gcedge") == true then
    has_2gcedge = true;
    local effects = { "DAMAGE_MULTIPLIER", "DAMAGE_MULTIPLIER", "LOW_HP_DAMAGE_BOOST" };
    for k,v in pairs( effects ) do
        local effect = GetGameEffectLoadTo( entity, v, true );
        ComponentSetValue2( effect, "frames", -1 );
    end
    local damage_models = EntityGetComponent( entity, "DamageModelComponent" );
    if damage_models ~= nil then
        for index,damage_model in pairs( damage_models ) do
            local max_hp = ComponentGetValue2( damage_model, "max_hp" );
            ComponentSetValue2( damage_model, "hp", max_hp / 5 );
        end
    end
elseif entity and has_2gcedge ~= false and ModSettingGet("spell_lab.force_2gcedge") ~= true then
    has_2gcedge = false;
    local effects = { "DAMAGE_MULTIPLIER", "LOW_HP_DAMAGE_BOOST" };
    for k,v in pairs( effects ) do
        local effect = GameGetGameEffect( entity, v );
        while effect ~= 0 do
            ComponentSetValue2( effect, "frames", 1 );
            EntityRemoveComponent( entity, effect );
            effect = GameGetGameEffect( entity, v );
        end
    end
    local damage_models = EntityGetComponent( entity, "DamageModelComponent" );
    if damage_models ~= nil then
        for index,damage_model in pairs( damage_models ) do
            local max_hp = ComponentGetValue2( damage_model, "max_hp" );
            ComponentSetValue2( damage_model, "hp", max_hp );
        end
    end
end

if has_unlimited_spells == nil then has_unlimited_spells = false; end
if entity and has_unlimited_spells ~= true and ModSettingGet("spell_lab.unlimited_spells") == true then
    has_unlimited_spells = true;
    local world_entity_id = GameGetWorldStateEntity()
    if world_entity_id ~= nil then
        local comp_worldstate = EntityGetFirstComponent( world_entity_id, "WorldStateComponent" );
        if comp_worldstate ~= nil then
            ComponentSetValue2( comp_worldstate, "perk_infinite_spells", true );
        end
    end
	GameRegenItemActionsInPlayer( entity );
    local inventory2 = EntityGetFirstComponent( entity, "Inventory2Component" );
    if inventory2 ~= nil then
        ComponentSetValue2( inventory2, "mForceRefresh", true );
        ComponentSetValue2( inventory2, "mActualActiveItem", 0 );
    end
elseif entity and has_unlimited_spells ~= false and ModSettingGet("spell_lab.unlimited_spells") ~= true then
    has_unlimited_spells = false;
    local world_entity_id = GameGetWorldStateEntity()
    if world_entity_id ~= nil then
        local comp_worldstate = EntityGetFirstComponent( world_entity_id, "WorldStateComponent" );
        if comp_worldstate ~= nil then
            ComponentSetValue2( comp_worldstate, "perk_infinite_spells", false );
        end
    end
end

if entity and ( ModSettingGet("spell_lab.edit_wands_everywhere") == true or GlobalsGetValue("spell_lab_challenge_active") == "1" ) then
    local effect = GetGameEffectLoadTo( entity, "EDIT_WANDS_EVERYWHERE", true );
    if effect ~= nil and effect ~= 0 then ComponentSetValue2( effect, "frames", 2 ); end
end

local highest_projectile_damage = 0;
local highest_damage_projectile = nil;
for k,v in pairs( EntityGetWithTag("projectile_player") or {} ) do
    local projectile = EntityGetFirstComponent( v, "ProjectileComponent" );
    if projectile then
        local damage = ComponentGetValue2( projectile, "damage" ) * 25;
        if damage > highest_projectile_damage then
            highest_damage_projectile = v;
            highest_projectile_damage = damage;
        end
    end
end
if highest_damage_projectile ~= nil then
    local x,y = EntityGetTransform( highest_damage_projectile );
    --draw_text( font, thousands_separator( math.floor(highest_projectile_damage) ), x, y + 8, 2/3, 2/3, 1, true, -2, 1, 1 );
end