dofile_once( "mods/spell_lab/files/helper.lua" );
dofile_once( "mods/spell_lab/files/lib/wands.lua" );
dofile_once( "mods/spell_lab/files/lib/helper.lua" );
ModLuaFileAppend( "data/scripts/gun/gun_actions.lua", "mods/spell_lab/files/append/gun_actions.lua" );
ModLuaFileAppend( "data/scripts/gun/gun.lua", "mods/spell_lab/files/append/gun.lua" );
ModLuaFileAppend( "data/scripts/init.lua", "mods/spell_lab/files/append/init.lua" );

function OnPlayerSpawned( player_entity )
    if ModSettingGet( "spell_lab.edit_wands_everywhere" ) == nil then
        ModSettingSet( "spell_lab.edit_wands_everywhere", true );
    end
    GlobalsSetValue( "mod_button_tr_width", "0" );
    local x, y = EntityGetTransform( player_entity );
    if not GameHasFlagRun("spell_lab_init") then
        GameAddFlagRun("spell_lab_init")
        EntityAddComponent2( player_entity, "LuaComponent", { script_damage_received="mods/spell_lab/files/scripts/player_damage_received.lua" });
        EntityAddComponent2( player_entity, "LuaComponent", { script_source_file="mods/spell_lab/files/scripts/player_update.lua", execute_every_n_frame=1 });
        EntityAddComponent2( player_entity, "LuaComponent", { script_shot="mods/spell_lab/files/scripts/player_shot.lua" });
        EntityAddComponent2( player_entity, "LuaComponent", { script_damage_about_to_be_received="mods/spell_lab/files/scripts/player_no_kill.lua" });
        EntityLoad('mods/spell_lab/files/biome_impl/wand_lab/wand_lab.xml', 14600, -6000 );
    end
end

function OnPausedChanged( is_paused )
    local entities_to_hide = EntityGetWithTag("hide_on_pause");
    for _,v in pairs( entities_to_hide or {} ) do
        local sprites = EntityGetComponentIncludingDisabled( v, "SpriteComponent" );
        for _,sprite in pairs( sprites or {} ) do
            EntitySetComponentIsEnabled( v, sprite, not is_paused );
            EntityRefreshSprite( v, sprite );
        end
    end
end

function OnWorldInitialized()
    local mod_button_reservation = tonumber( GlobalsGetValue( "mod_button_tr_width", "0" ) );
    GlobalsSetValue( "spell_lab_mod_button_reservation", tostring( mod_button_reservation ) );
    GlobalsSetValue( "mod_button_tr_width", tostring( mod_button_reservation + 15 ) );
end

local _ModTextFileGetContent = ModTextFileGetContent;
local p = false;
function OnWorldPreUpdate()
    --if p == false then
    --    print( tostring( _ModTextFileGetContent("data/scripts/gun/gun_actions.lua") ) );
    --    p = true;
    --end
    dofile( "mods/spell_lab/files/gui/update.lua" );
end

function OnWorldPostUpdate()
    GlobalsSetValue( "mod_button_tr_current", "0" );
end